/*
 *  rfid.c
 *  ideball_v02
 *
 *  Created by lixouda on 6/29/11.
 *  Copyright 2011 RWTH AACHEN. All rights reserved.
 *
 */

/*
 *  rfid.c
 *  ideaball_v01
 *
 *  Created by lixouda on 12/7/10.
 *  Copyright 2010 RWTH AACHEN. All rights reserved.
 *
 */

#include "rfid.h"

volatile uint8_t tagIndex;
volatile char tag[11]; 

uint8_t val;
extern  volatile uint8_t received;

volatile uint8_t bytesread = 0; 
volatile uint8_t tagReceived = 0;


ISR (USART0_RX_vect) //for rx
{
	PORTB = 0x00;

	val = uart0_read();
    received = 0;
	//received = 1;
	//return;
	
	if (tagReceived == 1)
		return;
	
		if (val == 0x02)
		{
			bytesread = 0; //new tag
			
		}
		else if (bytesread <10)
		{
    
			if (!((val == 0x0D) || (val == 0x0A) || ( val == 0x02)))
			{
				//uart_write(srx_tmp);
                //received = 1;
				tag[bytesread] = val;
				bytesread++;
			} 			
		}
		
		if (bytesread == 10)
		{
			tag[10] = '\0';
			tagReceived = 1;
			//	tmpvalue = getTagIndex(tag);
			//	uart_write(tmpvalue);		
			//uart_write('1');
			//	bytesread = 0;				
		}		
		//########## end rfid stuff ##########
		
}



uint8_t compareString(volatile char* array1, char* array2, int length)
{
	int i = 0;
	for ( i = 0; i < length; i++) 
	{
		
		if (array1[i] != array2[i])
		{
			return 1; //return 1 if not equivalent
		}
	}
	return 0; //return 0 if array1 equivalent to array2
}

int getTagIndex(volatile char t[]) { //, gloveArray, int maxindex) { 
	
	int index = 0;
    for (index = 0; index < 3; index++) {
	    if (!(compareString(t, tagsArray[index], TAGSIZE))) 
		{ // if match found
		    return index;
	    } 			
    }
	
    return 4;   
}	

int rfidCheck()
{
	/*
    if (tagReceived == 1) 
    {
        int i;
        for ( i = 0; i < 10; i++)
        {
            uart1_write(tag[i]);
        }
        tagReceived = 0;
        return 1;
    }*/
/*	if (received == 1)
	{
		uart1_write(val);
		received = 0;
		return 1;
	}
*/	
	return tagReceived;
}
