/*
 *  rfid.h
 *  ideball_v02
 *
 *  Created by lixouda on 6/29/11.
 *  Copyright 2011 RWTH AACHEN. All rights reserved.
 *
 */

/*
 *  rfid.h
 *  ideaball_v01
 *
 *  Created by lixouda on 12/7/10.
 *  Copyright 2010 RWTH AACHEN. All rights reserved.
 *
 */

#ifndef _RFID_H
#define _RFID_H

#include <avr/io.h>
#include <avr/interrupt.h>
#include "uart.h"

#define TAGSIZE 10
#define ARRAYSIZE 3

extern volatile uint8_t tagIndex;
extern char tagsArray[3][11];
extern volatile char tag[11]; 

extern uint8_t val;

extern volatile uint8_t bytesread; 
extern volatile uint8_t tagReceived;

uint8_t compareString(volatile char* array1, char* array2, int length);
int getTagIndex(volatile char t[]);
int rfidCheck(void);
#endif
